
-- Config Panel Text Strings
AchSnd.Text={
Title = "Achievement Sounds",
TitleSub = "Change how Achievement Sounds behaves by setting the options below",
Enable = "Enable the Add On to function",
Guild = "Trigger on guild member achievements",
Party = "Trigger on party member achievements",
Near  = "Trigger for people near you's achievements",
MSBT  = "Enable output to MSBT's notification frame",
Popup = "Enable Grats popup for 1-click gratting",
Sound = "Enable sound to notify you of an achievement",
CustomMP3 = "Enable custom alert.mp3 sound",
CustomOGG = "Enable custom alert.ogg sound",
Timeout = "Set the pop up's timeout",
Random = "Display a random grats message(checked) or default message",
Names = "Use playes's names in grat messages",
NNames = "Use Nicknames in grats when saved",
MaxNames = "Max number of names to display",
Multi = "Respond to multiple achievements with plural random msg",
MultiAmount = "    Over this amount gives a whole guild grat.",
DefaultMsg = "The message displayed if Random is off",
NewMsgBox = "Use the new \"Achievement Alert\" frame instead of old popup style. (Still needs Popup enabled to function)",
AutoFade = "Enable the new frame to fade when the mouse isn't over it",
MinAlpha = "The min. alpha the frame will fade to",
FadeDelay = "Time before frame fades to above"
}

-- Wait/Delay function
local waitTable = {};
local waitFrame = nil;

function AchSnd_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

-- General Settings / functions
AchSnd.ConfigLoaded = false
AchSnd.Checkclick = function()
	PlaySound( "GAMEGENERICBUTTONPRESS" )
end

-- Slider Mousewheel function
AchSnd.SliderMW = function(self, delta)
	local min,max = self:GetMinMaxValues()
	local step = self:GetValueStep()
	local value = self:GetValue()
	
	if (value > min) and (delta < 0) then 
		value = (value - step)
		if (value > min) then 
			self:SetValue( value )
		else
			self:SetValue( min )
		end
	end
	if (value < max) and (delta > 0) then
		value = (value + step)
		if (value < max) then
			self:SetValue( value )
		else
			self:SetValue( max )
		end
	end
end

--Panel
AchSnd.panel = CreateFrame( "Frame", "AchSndConfig", UIParent )
AchSnd.panel2 = CreateFrame( "Frame", "AchSndConfig", AchSnd.panel )
local me = AchSnd.panel
local me2 = AchSnd.panel2
me:SetScript("OnLoad", function()
	AchSnd.init()
end)


me.name = "Ach. Sounds"
me2:SetSize(380,475)
me2:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT")


local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13

-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( AchSnd.Text.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( AchSnd.Text.TitleSub )

-- Scroll Frame
	me.ScrollFrame = CreateFrame("ScrollFrame", "AchSndConfigScrollFrame", me, "UIPanelScrollFrameTemplate")
	me.ScrollFrame:SetScrollChild(me2)
	me.ScrollFrame:SetPoint("TOPRIGHT", me ,"TOPRIGHT", -30,- 64)
	me.ScrollFrame:SetPoint("BOTTOMRIGHT", me ,"BOTTOMRIGHT", -30, 10)
	me.ScrollFrame:SetSize(390, 400)

-- Enable Checkbox
	me.Enable = CreateFrame( "CheckButton", "AchSndConfigEnableCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Enable:SetPoint("TOPLEFT", me2 ,"TOPLEFT", X*1.25 , -Y/2 )
	me.Enable:SetSize( 26, 26 )
	me.Enable:SetScript( "OnClick", AchSnd.Checkclick )
	local last = me.Enable

-- Enable Checkbox Text
	me.Enable.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Enable.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Enable.Text:SetPoint( "RIGHT", -32, 0 )
	me.Enable.Text:SetHeight( 32 )
	me.Enable.Text:SetJustifyH( "LEFT" )
	me.Enable.Text:SetJustifyV( "TOP" )
	me.Enable.Text:SetText( AchSnd.Text.Enable )

-- Guild Checkbox	
	me.Guild = CreateFrame( "CheckButton", "AchSndConfigGuildCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Guild:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Guild:SetSize( 26, 26 )
	me.Guild:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Guild

-- Guild Checkbox Text
	me.Guild.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Guild.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Guild.Text:SetPoint( "RIGHT", -32, 0 )
	me.Guild.Text:SetHeight( 32 )
	me.Guild.Text:SetJustifyH( "LEFT" )
	me.Guild.Text:SetJustifyV( "TOP" )
	me.Guild.Text:SetText( AchSnd.Text.Guild )


-- Party Checkbox	
	me.Party = CreateFrame( "CheckButton", "AchSndConfigPartyCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Party:SetPoint("TOPLEFT", me.Guild ,"TOPLEFT", 0, -Y )
	me.Party:SetSize( 26, 26 )
	me.Party:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Party

-- Party Checkbox Text
	me.Party.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Party.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Party.Text:SetPoint( "RIGHT", -32, 0 )
	me.Party.Text:SetHeight( 32 )
	me.Party.Text:SetJustifyH( "LEFT" )
	me.Party.Text:SetJustifyV( "TOP" )
	me.Party.Text:SetText( AchSnd.Text.Party )

-- Near Checkbox	
	me.Near = CreateFrame( "CheckButton", "AchSndConfigNearCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Near:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Near:SetSize( 26, 26 )
	me.Near:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Near

--Near Checkbox Text
	me.Near.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Near.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Near.Text:SetPoint( "RIGHT", -32, 0 )
	me.Near.Text:SetHeight( 32 )
	me.Near.Text:SetJustifyH( "LEFT" )
	me.Near.Text:SetJustifyV( "TOP" )
	me.Near.Text:SetText( AchSnd.Text.Near )

-- MSBT Checkbox
	me.MSBT = CreateFrame( "CheckButton", "AchSndConfigMSBTCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.MSBT:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.MSBT:SetSize( 26, 26 )
	me.MSBT:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.MSBT

-- MSBT Checkbox Text
	me.MSBT.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.MSBT.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.MSBT.Text:SetPoint( "RIGHT", -32, 0 )
	me.MSBT.Text:SetHeight( 32 )
	me.MSBT.Text:SetJustifyH( "LEFT" )
	me.MSBT.Text:SetJustifyV( "TOP" )
	me.MSBT.Text:SetText( AchSnd.Text.MSBT )

-- Popup Checkbox
	me.Popup = CreateFrame( "CheckButton", "AchSndConfigPopupCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Popup:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Popup:SetSize( 26, 26 )
	me.Popup:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Popup

-- Popup Checkbox Text
	me.Popup.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Popup.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Popup.Text:SetPoint( "RIGHT", -32, 0 )
	me.Popup.Text:SetHeight( 32 )
	me.Popup.Text:SetJustifyH( "LEFT" )
	me.Popup.Text:SetJustifyV( "TOP" )
	me.Popup.Text:SetText( AchSnd.Text.Popup )

-- Timeout Slider	
	me.Timeout = CreateFrame( "Slider", "AchSndConfigTimeoutSlider", me2, "OptionsSliderTemplate" )
	me.Timeout:SetMinMaxValues( 0, 60 )
	me.Timeout:SetOrientation("HORIZONTAL")
	me.Timeout:SetPoint("TOPLEFT", last ,"TOPLEFT", 0 , -Y )
	me.Timeout:SetValueStep( 1 )
	me.Timeout:SetWidth( 240 )
	me.Timeout:SetHeight( 16 )
	me.Timeout:SetScript( "OnValueChanged", function()
		if not(AchSnd.ConfigLoaded) then
			AchSnd_wait(3, AchSnd.Init)
			AchSnd.ConfigLoaded = true
		end
		me.Timeout.Val:SetNumber( me.Timeout:GetValue() )
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		getglobal(me.FadeDelay:GetName() .. 'High'):SetText(tostring(me.Timeout:GetValue()))
		me.FadeDelay:SetMinMaxValues( 0, me.Timeout:GetValue() )
	end)
	getglobal(me.Timeout:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(me.Timeout:GetName() .. 'High'):SetText('60'); --Sets the right-side slider text (default is "High").
	getglobal(me.Timeout:GetName() .. 'Text'):SetText(AchSnd.Text.Timeout); --Sets the "title" text (top-centre of slider).

-- Timeout Slider mousewheel settings
	me.Timeout:EnableMouseWheel(true)
	me.Timeout:SetScript("OnMouseWheel", function(self, delta)
		AchSnd.SliderMW(self, delta)
	end)
	last = me.Timeout

-- Timeout Editbox	
	me.Timeout.Val=CreateFrame("EditBox", "AchSndConfigTimeoutValue", me2, "InputBoxTemplate")
	me.Timeout.Val:SetFontObject("ChatFontNormal")
	me.Timeout.Val:SetTextInsets(0, 0, 3, 3)
	me.Timeout.Val:SetPoint("BOTTOMLEFT", last , "BOTTOMRIGHT", X , -8)
	me.Timeout.Val:SetPoint("RIGHT", -32, 0)
	me.Timeout.Val:SetHeight(19)
	me.Timeout.Val:SetWidth(32)
	me.Timeout.Val:SetNumeric(true)
	me.Timeout.Val:SetAutoFocus(false)
	me.Timeout.Val:SetMaxLetters( 2 )
	me.Timeout.Val:SetScript("OnEnterPressed" , function(self)
		local value = me.Timeout.Val:GetNumber()
		if (value >= 0 and value <= 60) then
			me.Timeout:SetValue( value )
		else
			me.Timeout.Val:SetNumber( me.Timeout:GetValue() )
		end
		me.Timeout.Val:ClearFocus()
	end)
	me.Timeout.Val:SetScript("OnEscapePressed", function(self)
		me.Timeout.Val:SetNumber( me.Timeout:GetValue() )
		me.Timeout.Val:ClearFocus()
	end)

-- Sound Checkbox	
	me.Sound = CreateFrame( "CheckButton", "AchSndConfigSoundCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Sound:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Sound:SetSize( 26, 26 )
	me.Sound:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Sound

-- Sound Checkbox Text
	me.Sound.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Sound.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Sound.Text:SetPoint( "RIGHT", -32, 0 )
	me.Sound.Text:SetHeight( 32 )
	me.Sound.Text:SetJustifyH( "LEFT" )
	me.Sound.Text:SetJustifyV( "TOP" )
	me.Sound.Text:SetText( AchSnd.Text.Sound )

-- Custom MP3 Checkbox	
	me.CustomMP3 = CreateFrame( "CheckButton", "AchSndConfigCustomMP3Checkbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.CustomMP3:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.CustomMP3:SetSize( 26, 26 )
	me.CustomMP3:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.CustomMP3

-- Custom MP3 Text
	me.CustomMP3.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.CustomMP3.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.CustomMP3.Text:SetPoint( "RIGHT", -32, 0 )
	me.CustomMP3.Text:SetHeight( 32 )
	me.CustomMP3.Text:SetJustifyH( "LEFT" )
	me.CustomMP3.Text:SetJustifyV( "TOP" )
	me.CustomMP3.Text:SetText( AchSnd.Text.CustomMP3 )

-- Custom OGG Checkbox	
	me.CustomOGG = CreateFrame( "CheckButton", "AchSndConfigCustomOGGCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.CustomOGG:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.CustomOGG:SetSize( 26, 26 )
	me.CustomOGG:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.CustomOGG

-- Custom OGG Text
	me.CustomOGG.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.CustomOGG.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.CustomOGG.Text:SetPoint( "RIGHT", -32, 0 )
	me.CustomOGG.Text:SetHeight( 32 )
	me.CustomOGG.Text:SetJustifyH( "LEFT" )
	me.CustomOGG.Text:SetJustifyV( "TOP" )
	me.CustomOGG.Text:SetText( AchSnd.Text.CustomOGG )

-- Random Message Checkbox
	me.Random = CreateFrame( "CheckButton", "AchSndConfigRandomCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Random:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Random:SetSize( 26, 26 )
	me.Random:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Random

-- Random Message Checkbox Text
	me.Random.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Random.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Random.Text:SetPoint( "RIGHT", -32, 0 )
	me.Random.Text:SetHeight( 32 )
	me.Random.Text:SetJustifyH( "LEFT" )
	me.Random.Text:SetJustifyV( "TOP" )
	me.Random.Text:SetText( AchSnd.Text.Random )

-- Names in Random messages checkbox
	me.Names = CreateFrame( "CheckButton", "AchSndConfigUseNamesCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Names:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Names:SetSize( 26, 26 )
	me.Names:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Names

-- Names in Random Message Checkbox Text
	me.Names.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Names.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Names.Text:SetPoint( "RIGHT", -32, 0 )
	me.Names.Text:SetHeight( 32 )
	me.Names.Text:SetJustifyH( "LEFT" )
	me.Names.Text:SetJustifyV( "TOP" )
	me.Names.Text:SetText( AchSnd.Text.Names )

-- NickNames in Random messages checkbox
	me.NNames = CreateFrame( "CheckButton", "AchSndConfigUseNickNamesCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.NNames:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.NNames:SetSize( 26, 26 )
	me.NNames:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.NNames

-- NickNames in Random Message Checkbox Text
	me.NNames.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.NNames.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.NNames.Text:SetPoint( "RIGHT", -32, 0 )
	me.NNames.Text:SetHeight( 32 )
	me.NNames.Text:SetJustifyH( "LEFT" )
	me.NNames.Text:SetJustifyV( "TOP" )
	me.NNames.Text:SetText( AchSnd.Text.NNames )

-- Max Names Slider
	me.MaxNames = CreateFrame( "Slider", "AchSndConfigMaxNamesSlider", me2, "OptionsSliderTemplate" )
	me.MaxNames:SetMinMaxValues( 1, 10 )
	me.MaxNames:SetOrientation("HORIZONTAL")
	me.MaxNames:SetPoint("TOPLEFT", last ,"TOPLEFT", 0 , -Y*1.25 )
	me.MaxNames:SetValueStep( 1 )
	me.MaxNames:SetWidth( 240 )
	me.MaxNames:SetHeight( 16 )
	me.MaxNames:SetScript( "OnValueChanged", function()
		me.MaxNames.Val:SetNumber( me.MaxNames:GetValue() )
		PlaySound( "GAMEGENERICBUTTONPRESS" )
	end)
	getglobal(me.MaxNames:GetName() .. 'Low'):SetText('1'); --Sets the left-side slider text (default is "Low").
	getglobal(me.MaxNames:GetName() .. 'High'):SetText('10'); --Sets the right-side slider text (default is "High").
	getglobal(me.MaxNames:GetName() .. 'Text'):SetText(AchSnd.Text.MaxNames); --Sets the "title" text (top-centre of slider).

-- Multi Amount Slider mousewheel settings
	me.MaxNames:EnableMouseWheel(true)
	me.MaxNames:SetScript("OnMouseWheel", function(self, delta)
		AchSnd.SliderMW(self, delta)
	end)
	last = me.MaxNames

-- Max Names Amount Editbox	
	me.MaxNames.Val=CreateFrame("EditBox", "AchSndConfigMaxNamesValue", me2, "InputBoxTemplate")
	me.MaxNames.Val:SetFontObject("ChatFontNormal")
	me.MaxNames.Val:SetTextInsets(0, 0, 3, 3)
	me.MaxNames.Val:SetPoint("BOTTOMLEFT", last , "BOTTOMRIGHT", X , -8)
	me.MaxNames.Val:SetPoint("RIGHT", -32, 0)
	me.MaxNames.Val:SetHeight(19)
	me.MaxNames.Val:SetWidth(32)
	me.MaxNames.Val:SetNumeric(true)
	me.MaxNames.Val:SetAutoFocus(false)
	me.MaxNames.Val:SetMaxLetters( 4 )
	me.MaxNames.Val:SetScript("OnEnterPressed" , function(self)
		local value = me.MaxNames.Val:GetNumber()
		if (value >= 0 and value <= 10) then
			me.MaxNames:SetValue( value )
		else
			me.MaxNames.Val:SetNumber( me.MaxNames:GetValue() )
		end
		me.MaxNames.Val:ClearFocus()
	end)
	me.MaxNames.Val:SetScript("OnEscapePressed", function(self)
		me.MaxNames.Val:SetNumber( me.MaxNames:GetValue() )
		me.MaxNames.Val:ClearFocus()
	end)

-- Multi Grat Message Checkbox
	me.Multi = CreateFrame( "CheckButton", "AchSndConfigMultiCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.Multi:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.Multi:SetSize( 26, 26 )
	me.Multi:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.Multi

-- Multi Grat Checkbox Text
	me.Multi.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Multi.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.Multi.Text:SetPoint( "RIGHT", -32, 0 )
	me.Multi.Text:SetHeight( 32 )
	me.Multi.Text:SetJustifyH( "LEFT" )
	me.Multi.Text:SetJustifyV( "TOP" )
	me.Multi.Text:SetText( AchSnd.Text.Multi )

-- Multi Amount Slider	
	me.MultiAmount = CreateFrame( "Slider", "AchSndConfigMultiAmountSlider", me2, "OptionsSliderTemplate" )
	me.MultiAmount:SetMinMaxValues( 0, 129 )
	me.MultiAmount:SetOrientation("HORIZONTAL")
	me.MultiAmount:SetPoint("TOPLEFT", last ,"TOPLEFT", 0 , -Y*1.25 )
	me.MultiAmount:SetValueStep( 1 )
	me.MultiAmount:SetWidth( 240 )
	me.MultiAmount:SetHeight( 16 )
	me.MultiAmount:SetScript( "OnValueChanged", function()
		me.MultiAmount.Val:SetNumber( me.MultiAmount:GetValue() )
		PlaySound( "GAMEGENERICBUTTONPRESS" )
	end)
	getglobal(me.MultiAmount:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(me.MultiAmount:GetName() .. 'High'):SetText('129'); --Sets the right-side slider text (default is "High").
	getglobal(me.MultiAmount:GetName() .. 'Text'):SetText(AchSnd.Text.MultiAmount); --Sets the "title" text (top-centre of slider).

-- Multi Amount Slider mousewheel settings
	me.MultiAmount:EnableMouseWheel(true)
	me.MultiAmount:SetScript("OnMouseWheel", function(self, delta)
		AchSnd.SliderMW(self, delta)
	end)
	last = me.MultiAmount

-- Multi Amount Editbox	
	me.MultiAmount.Val=CreateFrame("EditBox", "AchSndConfigMultiAmountValue", me2, "InputBoxTemplate")
	me.MultiAmount.Val:SetFontObject("ChatFontNormal")
	me.MultiAmount.Val:SetTextInsets(0, 0, 3, 3)
	me.MultiAmount.Val:SetPoint("BOTTOMLEFT", last , "BOTTOMRIGHT", X , -8)
	me.MultiAmount.Val:SetPoint("RIGHT", -32, 0)
	me.MultiAmount.Val:SetHeight(19)
	me.MultiAmount.Val:SetWidth(32)
	me.MultiAmount.Val:SetNumeric(true)
	me.MultiAmount.Val:SetAutoFocus(false)
	me.MultiAmount.Val:SetMaxLetters( 4 )
	me.MultiAmount.Val:SetScript("OnEnterPressed" , function(self)
		local value = me.MultiAmount.Val:GetNumber()
		if (value >= 0 and value <= 129) then
			me.MultiAmount:SetValue( value )
		else
			me.MultiAmount.Val:SetNumber( me.MultiAmount:GetValue() )
		end
		me.MultiAmount.Val:ClearFocus()
	end)
	me.MultiAmount.Val:SetScript("OnEscapePressed", function(self)
		me.MultiAmount.Val:SetNumber( me.MultiAmount:GetValue() )
		me.MultiAmount.Val:ClearFocus()
	end)


-- Default Message Editbox
	me.Default = CreateFrame( "EditBox", "AchSndConfigDefaultMsgEditbox", me2, "InputBoxTemplate" )
	me.Default:SetFontObject("ChatFontNormal")
	me.Default:SetTextInsets(0, 0, 3, 3)
	me.Default:SetPoint("TOPLEFT", last , "TOPLEFT", 0 ,-Y*2 )
	me.Default:SetPoint("RIGHT", -32, 0)
	me.Default:SetHeight(19)
	me.Default:SetWidth(50)
	me.Default:SetAutoFocus(false)
	me.Default:SetMaxLetters( 254 )
	me.Default:SetScript("OnEnterPressed" , function(self)
		me.Default:ClearFocus()
		if ( AchSnd.TextScanError(me.Default:GetText() ) ) then
			StaticPopup_Show("AchSnd.TextError")
			me.Default:SetText( setting.DefaultMsg )
		end
	end)
	me.Default:SetScript("OnEscapePressed", function(self)
		me.Default:SetText( AchSnd_Settings.DefaultMsg )
		me.Default:ClearFocus()
	end)
	last = me.Default

-- Default Message Editbox Text (Above the edit box)
	me.Default.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.Default.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", 0 , Y/4 )
	me.Default.Text:SetPoint( "RIGHT", -32, 0 )
	me.Default.Text:SetHeight( 32 )
	me.Default.Text:SetJustifyH( "LEFT" )
	me.Default.Text:SetJustifyV( "TOP" )
	me.Default.Text:SetText( AchSnd.Text.DefaultMsg )

-- New Alert Checkbox
	me.NewMsgBox = CreateFrame( "CheckButton", "AchSndConfigNewMsgBoxCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.NewMsgBox:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.NewMsgBox:SetSize( 26, 26 )
	me.NewMsgBox:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.NewMsgBox

-- New Alert Checkbox Text
	me.NewMsgBox.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.NewMsgBox.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.NewMsgBox.Text:SetPoint( "RIGHT", -32, 0 )
	me.NewMsgBox.Text:SetHeight( 32 )
	me.NewMsgBox.Text:SetJustifyH( "LEFT" )
	me.NewMsgBox.Text:SetJustifyV( "TOP" )
	me.NewMsgBox.Text:SetText( AchSnd.Text.NewMsgBox )

-- New Alert Autofade Checkbox
	me.AutoFade = CreateFrame( "CheckButton", "AchSndConfigNewMsgBoxCheckbox", me2, "InterfaceOptionsCheckButtonTemplate" )
	me.AutoFade:SetPoint("TOPLEFT", last ,"TOPLEFT", 0, -Y )
	me.AutoFade:SetSize( 26, 26 )
	me.AutoFade:SetScript( "OnClick", AchSnd.Checkclick )
	last = me.AutoFade

-- New Alert Autofade Checkbox Text
	me.AutoFade.Text = me2:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.AutoFade.Text:SetPoint( "BOTTOMLEFT", last , "BOTTOMLEFT", X*2 , -TxtY )
	me.AutoFade.Text:SetPoint( "RIGHT", -32, 0 )
	me.AutoFade.Text:SetHeight( 32 )
	me.AutoFade.Text:SetJustifyH( "LEFT" )
	me.AutoFade.Text:SetJustifyV( "TOP" )
	me.AutoFade.Text:SetText( AchSnd.Text.AutoFade )

-- Alert Frame Minimum Alpha Slider
	me.MinAlpha = CreateFrame( "Slider", "AchSndConfigMinAlphaSlider", me2, "OptionsSliderTemplate" )
	me.MinAlpha:SetMinMaxValues( 0, 1 )
	me.MinAlpha:SetOrientation("HORIZONTAL")
	me.MinAlpha:SetPoint("TOPLEFT", last ,"TOPLEFT", 0 , -Y*1.5 )
	me.MinAlpha:SetValueStep( .05 )
	me.MinAlpha:SetWidth( 240 )
	me.MinAlpha:SetHeight( 16 )
	me.MinAlpha:SetScript( "OnValueChanged", function()
		me.MinAlpha.Val:SetNumber( me.MinAlpha:GetValue() )
		PlaySound( "GAMEGENERICBUTTONPRESS" )
	end)
	getglobal(me.MinAlpha:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(me.MinAlpha:GetName() .. 'High'):SetText('1'); --Sets the right-side slider text (default is "High").
	getglobal(me.MinAlpha:GetName() .. 'Text'):SetText(AchSnd.Text.MinAlpha); --Sets the "title" text (top-centre of slider).


-- Alert Frame Minimum Alpha Slider mousewheel settings
	me.MinAlpha:EnableMouseWheel(true)
	me.MinAlpha:SetScript("OnMouseWheel", function(self, delta)
		AchSnd.SliderMW(self, delta)
		local val = self:GetValue()
		val = val * 100
		val = math.ceil( val )
		val = val / 100
		self:SetValue( val )
	end)
	last = me.MinAlpha

-- Alert Frame Minimum Alpha Editbox	
	me.MinAlpha.Val=CreateFrame("EditBox", "AchSndConfigTimeoutValue", me2, "InputBoxTemplate")
	me.MinAlpha.Val:SetFontObject("ChatFontNormal")
	me.MinAlpha.Val:SetTextInsets(0, 0, 3, 3)
	me.MinAlpha.Val:SetPoint("BOTTOMLEFT", last , "BOTTOMRIGHT", X , -8)
	me.MinAlpha.Val:SetPoint("RIGHT", -32, 0)
	me.MinAlpha.Val:SetHeight(19)
	me.MinAlpha.Val:SetWidth(32)
	me.MinAlpha.Val:SetAutoFocus(false)
	me.MinAlpha.Val:SetMaxLetters( 5 )
	me.MinAlpha.Val:SetScript("OnEnterPressed" , function(self)
		local value = me.MinAlpha.Val:GetNumber()
		if (value >= 0 and value <= 1) then
			me.MinAlpha:SetValue( value )
		else
			me.MinAlpha.Val:SetNumber( me.MinAlpha:GetValue() )
		end
		me.MinAlpha.Val:ClearFocus()
	end)
	me.MinAlpha.Val:SetScript("OnEscapePressed", function(self)
		me.MinAlpha.Val:SetNumber( me.MinAlpha:GetValue() )
		me.MinAlpha.Val:ClearFocus()
	end)


-- Alert Frame Fade Delay Slider
	me.FadeDelay = CreateFrame( "Slider", "AchSndConfigFadeDelaySlider", me2, "OptionsSliderTemplate" )
	me.FadeDelay:SetMinMaxValues( 0, me.Timeout:GetValue() )
	me.FadeDelay:SetOrientation("HORIZONTAL")
	me.FadeDelay:SetPoint("TOPLEFT", last ,"TOPLEFT", 0 , -Y*1.5 )
	me.FadeDelay:SetValueStep( .5 )
	me.FadeDelay:SetWidth( 240 )
	me.FadeDelay:SetHeight( 16 )
	me.FadeDelay:SetScript( "OnValueChanged", function()
		me.FadeDelay.Val:SetNumber( me.FadeDelay:GetValue() )
		PlaySound( "GAMEGENERICBUTTONPRESS" )
	end)
	getglobal(me.FadeDelay:GetName() .. 'Low'):SetText('0 (No Delay)'); --Sets the left-side slider text (default is "Low").
	getglobal(me.FadeDelay:GetName() .. 'High'):SetText(tostring(me.Timeout:GetValue())); --Sets the right-side slider text (default is "High").
	getglobal(me.FadeDelay:GetName() .. 'Text'):SetText(AchSnd.Text.FadeDelay); --Sets the "title" text (top-centre of slider).

-- Alert Frame Fade Delay Slider mousewheel settings
	me.FadeDelay:EnableMouseWheel(true)
	me.FadeDelay:SetScript("OnMouseWheel", function(self, delta)
		AchSnd.SliderMW(self, delta)
	end)
	last = me.FadeDelay

-- Alert Frame Fade Delay Editbox	
	me.FadeDelay.Val=CreateFrame("EditBox", "AchSndConfigFadeDelayValue", me2, "InputBoxTemplate")
	me.FadeDelay.Val:SetFontObject("ChatFontNormal")
	me.FadeDelay.Val:SetTextInsets(0, 0, 3, 3)
	me.FadeDelay.Val:SetPoint("BOTTOMLEFT", last , "BOTTOMRIGHT", X , -8)
	me.FadeDelay.Val:SetPoint("RIGHT", -32, 0)
	me.FadeDelay.Val:SetHeight(19)
	me.FadeDelay.Val:SetWidth(32)
	me.FadeDelay.Val:SetAutoFocus(false)
	me.FadeDelay.Val:SetMaxLetters( 5 )
	me.FadeDelay.Val:SetScript("OnEnterPressed" , function(self)
		local value = me.FadeDelay.Val:GetNumber()
		if (value >= 0 and value <= me.Timeout:GetValue()) then
			me.FadeDelay:SetValue( value )
		else
			me.FadeDelay.Val:SetNumber( me.FadeDelay:GetValue() )
		end
		me.FadeDelay.Val:ClearFocus()
	end)
	me.FadeDelay.Val:SetScript("OnEscapePressed", function(self)
		me.FadeDelay.Val:SetNumber( me.FadeDelay:GetValue() )
		me.FadeDelay.Val:ClearFocus()
	end)

-- Frame Settings Test Button
	me.TestButton = CreateFrame("Button", "AchSndTestButton", me2, "UIPanelButtonTemplate" )
	me.TestButton:SetPoint("TOPLEFT", last, "TOPLEFT", ((me2:GetWidth() / 2) -13) , -Y )
	me.TestButton:SetSize( 150, 25)
	me.TestButton:SetText("Test")
	me.TestButton:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.MBox.Test = true
		AchSnd.MBox.text = "This is a test for checking the Alpha of the frame"
		GameMenuFrame:Hide()
		InterfaceOptionsFrame:Hide()
		AchSnd.MsgFrame:Show()
		return
	end)
	
--	End of frame
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--
AchSnd.Init = function(...)
	if (AchSnd.MBox.mode == "TEST") then
		return
	end
	
	local setting = AchSnd_Settings
	local me = AchSnd.panel
	me.Enable:SetChecked( setting.Enable )
	me.Guild:SetChecked( setting.Guild )
	me.Party:SetChecked( setting.Party )
	me.Near:SetChecked( setting.Near )
	me.MSBT:SetChecked( setting.MSBT )
	me.Popup:SetChecked( setting.Popup )
	me.Timeout:SetValue( setting.Timeout)
	me.Timeout.Val:SetCursorPosition( 0 )
	me.Timeout.Val:SetNumber( setting.Timeout )
	me.Sound:SetChecked( setting.Sound )
	me.CustomMP3:SetChecked( setting.CustomMP3 )
	me.CustomOGG:SetChecked( setting.CustomOGG )
	me.Random:SetChecked( setting.Random )
	me.Names:SetChecked( setting.Names )
	me.NNames:SetChecked( setting.NNames )
	me.MaxNames:SetValue( setting.MaxNames)
	me.MaxNames.Val:SetCursorPosition( 0 )
	me.MaxNames.Val:SetNumber( setting.MaxNames )
	me.Multi:SetChecked( setting.Multi )
	me.MultiAmount:SetValue( setting.MultiAmount)
	me.MultiAmount.Val:SetCursorPosition( 0 )
	me.MultiAmount.Val:SetNumber( setting.MultiAmount )
	me.Default:SetCursorPosition( 0 )
	me.Default:SetText( setting.DefaultMsg )
	me.NewMsgBox:SetChecked( setting.NewMsgBox )
	me.AutoFade:SetChecked( setting.AutoFade )
	me.MinAlpha:SetValue( setting.MinAlpha)
	me.MinAlpha.Val:SetCursorPosition( 0 )
	me.MinAlpha.Val:SetNumber( setting.MinAlpha )
	me.FadeDelay:SetValue( setting.FadeDelay)
	me.FadeDelay.Val:SetCursorPosition( 0 )
	me.FadeDelay.Val:SetNumber( setting.FadeDelay )
	
end

-- Reset config panel and settings to DEFAULT
AchSnd.Reset = function(...)
	local def = AchSnd_Defaults
	local cur = AchSnd_Settings
	cur.Enable = def.Enable
	cur.Guild = def.Guild
	cur.Party = def.Party
	cur.Near = def.Near
	cur.MSBT = def.MSBT
	cur.Popup = def.Popup
	cur.Timeout = def.Timeout
	cur.Sound = def.Sound
	cur.CustomMP3 = def.CustomMP3
	cur.CustomOGG = def.CustomOGG
	cur.Random = def.Random
	cur.Names = def.Names
	cur.NNames = def.NNames
	cur.MaxNames = def.MaxNames
	cur.Multi = def.Multi
	cur.MiltiAmount = def.MultiAmount
	cur.DefaultMsg = def.DefaultMsg
	cur.NewMsgBox = def.NewMsgBox
	cur.AutoFade = def.AutoFade
	cur.MinAlpha = def.MinAlpha
	cur.FadeDelay = def.FadeDelay
	AchSnd.Init()
end



me.refresh = function(self)
	AchSnd.Init()
end

me.default = function (self)
	AchSnd.Reset()
end

me.cancel = function (self)
	AchSnd.Init()
end

-- Save settings from config panel
me.okay = function(self)
	local setting = AchSnd_Settings

	-- Enable CheckBox
	if me.Enable:GetChecked() ~= setting.Enable then
		setting.Enable = me.Enable:GetChecked()
	end
	
	-- Guild CheckBox
	if me.Guild:GetChecked() ~= setting.Guild then
		setting.Guild = me.Guild:GetChecked()
	end
		
	-- Party CheckBox
	if me.Party:GetChecked() ~= setting.Party then
		setting.Party = me.Party:GetChecked()
	end
	
	-- Near CheckBox
	if me.Near:GetChecked() ~= setting.Near then
		setting.Near = me.Near:GetChecked()
	end
	
	-- MSBT CheckBox
	if me.MSBT:GetChecked() ~= setting.MSBT then
		setting.MSBT = me.MSBT:GetChecked()
	end
		
	-- Popup CheckBox
	if me.Popup:GetChecked() ~= setting.Popup then
		setting.Popup = me.Popup:GetChecked()
	end
	
	-- Timeout Slider
	if (me.Timeout:GetValue() ~= setting.Timeout) then
		setting.Timeout = me.Timeout:GetValue()
	end

	-- Sound CheckBox
	if me.Sound:GetChecked() ~= setting.Sound then
		setting.Sound = me.Sound:GetChecked()
	end
	
	-- CustomMP3 CheckBox
	if me.CustomMP3:GetChecked() ~= setting.CustomMP3 then
		setting.CustomMP3 = me.CustomMP3:GetChecked()
	end
	
	-- CustomOGG CheckBox
	if me.CustomOGG:GetChecked() ~= setting.CustomOGG then
		setting.CustomOGG = me.CustomOGG:GetChecked()
	end

	-- Random Message Enable CheckBox
	if me.Random:GetChecked() ~= setting.Random then
		setting.Random = me.Random:GetChecked()
	end
	
	-- Use Names in Random Message Enable CheckBox
	if me.Names:GetChecked() ~= setting.Names then
		setting.Names = me.Names:GetChecked()
	end
	
	-- Use NickNames in Random Message Enable CheckBox
	if me.NNames:GetChecked() ~= setting.NNames then
		setting.NNames = me.NNames:GetChecked()
	end
	
	-- Max Names Slider
	if (me.MaxNames:GetValue() ~= setting.MaxNames) then
		setting.MaxNames = me.MaxNames:GetValue()
	end

	-- Multi Guild Message Enable CheckBox
	if me.Multi:GetChecked() ~= setting.Multi then
		setting.Multi = me.Multi:GetChecked()
	end
	
	-- Multi Amount Slider
	if (me.MultiAmount:GetValue() ~= setting.MultiAmount) then
		setting.MultiAmount = me.MultiAmount:GetValue()
	end
	
	-- Default Message EditBox
	if (me.Default:GetText() ~= setting.DefaultMsg) then
		setting.DefaultMsg = me.Default:GetText()
	end
	
	-- New Alert Frame Enable Checkbox
	if me.NewMsgBox:GetChecked() ~= setting.NewMsgBox then
		setting.NewMsgBox = me.NewMsgBox:GetChecked()
	end
	
	-- New Alert Frame Auto Fade Enable Checkbox
	if me.AutoFade:GetChecked() ~= setting.AutoFade then
		setting.AutoFade = me.AutoFade:GetChecked()
	end
		
	-- Min Alpha Slider
	if (me.MinAlpha:GetValue() ~= setting.MinAlpha) then
		setting.MinAlpha = me.MinAlpha:GetValue()
	end

	-- Fade Delay Slider
	if (me.FadeDelay:GetValue() ~= setting.FadeDelay) then
		setting.FadeDelay = me.FadeDelay:GetValue()
	end


end

-- Register the config panel
InterfaceOptions_AddCategory( me )


